package main

import (
    "log"
    "fmt"
    "net/http"
    "errors"

    "github.com/wader/goutubedl"
)

func getRedirectURL(input string) (string, error) {
    request, err := http.NewRequest("GET", input, nil)
    if err != nil {
        return "", err
    }

    client := &http.Client{}
    resp, err := client.Do(request)
    if err != nil {
        return "", err
    }

    log.Printf("Found new URL: %s", resp.Request.URL.String())
    return resp.Request.URL.String(), nil
}

func getLargestFormat(input goutubedl.Result, sizeLimit float64) (format goutubedl.Format, err error) {
    for i := len(input.Formats())-1; i >= 0; i-- {
        size := input.Formats()[i].FilesizeApprox
        if size <= sizeLimit {
            return input.Formats()[i], nil
        }
    }
    return goutubedl.Format{}, errors.New(fmt.Sprintf("Could not find a video format that is under the size limit of %f", sizeLimit))
}
